/********************************************************************
 * Code accompanying "The Embedded Angle" column in CUJ
 * Copyright 2002-2003 by Miro Samek, http://www.quantum-leaps.com 
 * All Rights Reserved.
 *******************************************************************/
#ifndef fsm_h
#define fsm_h

typedef short Signal;
typedef struct Event Event;
typedef struct Fsm Fsm;
typedef void (*State)(Fsm *, Event const *);

struct Event {
   Signal sig;
};

enum {                                        /* reserved signals */
   ENTRY_SIG, 
   EXIT_SIG,
   USER_SIG
};

struct Fsm {
  State state__;
};
void FsmInitialTran_(Fsm *me, State target);
void FsmTran_(Fsm *me, State targ);

#define FsmCtor_(me_, init_) ((me_)->state__ = (State)(init_))
#define FsmInit(me_, e_)     (*(me_)->state__)((me_), (e_)) 
#define FsmDispatch(me_, e_) (*(me_)->state__)((me_), (e_))

#endif /* fsm_h */
