#include <vector>
#include <algorithm>
#include "segset.h"
#include <iostream>

template<class T> struct print : public std::unary_function<T, void>
{
    print(std::ostream& out) : os(out) {}
    void operator() (T x) { os << x;}
    std::ostream& os;
};

int main()
{
    std::vector<Segment> seg_vec;
    MutableSegmentSet segset;
    
    seg_vec.push_back(Segment(2, 1, 5, 4));
    seg_vec.push_back(Segment(0, 3, 5, 3));
    seg_vec.push_back(Segment(1, 4, 4, 1));
    seg_vec.push_back(Segment(2, 2, 5, 2));
    
    std::cout << std::endl;
    std::cout << "Setting scan position to 0\n";
    segset.set_scan_pos(0);
    std::cout << "Inserting segment ((0,3) (5,3))\n";
    segset.insert(seg_vec[1]);

    std::cout << "segment order:\n";
    std::for_each(segset.begin(), segset.end(), print<Segment>(std::cout));
    std::cout << std::endl;
    
    std::cout << "Setting scan position to 1\n";
    segset.set_scan_pos(1);
    std::cout << "Inserting segment ((1,4) (4,1))\n";
    segset.insert(seg_vec[2]);
    std::cout << "segment order:\n";
    std::for_each(segset.begin(), segset.end(), print<Segment>(std::cout));
    std::cout << std::endl;
    
    std::cout << "Setting scan position to 2\n";
    segset.set_scan_pos(2);
    std::cout << "Inserting segment ((2,1) (5,4))\n";
    segset.insert(seg_vec[0]);
    std::cout << "Inserting segment ((2,2) (5,2))\n";
    segset.insert(seg_vec[3]);
    std::cout << "segment order:\n";
    std::for_each(segset.begin(), segset.end(), print<Segment>(std::cout));
    std::cout << std::endl;
    
    std::cout << "Setting scan position to 3\n";
    segset.set_scan_pos(3);
    std::cout << "segment order:\n";
    std::for_each(segset.begin(), segset.end(), print<Segment>(std::cout));
    std::cout << std::endl;

    std::cout << "Setting scan position to 4\n";
    segset.set_scan_pos(4);
    std::cout << "segment order:\n";
    std::for_each(segset.begin(), segset.end(), print<Segment>(std::cout));
    std::cout << std::endl;
}
