#ifndef SEGMENT_H
#define SEGMENT_H

#include <iostream>

class Segment
{
    public:
        Segment(int lx, int ly, int ux, int uy) : lower_x(lx), lower_y(ly), 
                                              upper_x(ux), upper_y(uy) {}
        int evaluate(const int xcoord) const
        {
            return lower_y + slope() * (xcoord - lower_x);
        }
        int slope() const
        {
            return (upper_y - lower_y)/(upper_x - lower_x);
        }
        
        int LowerX() const { return lower_x; }
        int LowerY() const { return lower_y; }
        int UpperX() const { return upper_x; }
        int UpperY() const { return upper_y; }
    private:
        int lower_x, lower_y;
        int upper_x, upper_y;
};

inline std::ostream& operator<< (std::ostream& os, const Segment& seg)
{
    os << "(" << seg.LowerX() << ", " << seg.LowerY() << ")";
    os << " (" << seg.UpperX() << ", " << seg.UpperY() << ")" << std::endl;
    return os;
}

#endif
