#include <algorithm>
#include "segset.h"

MutableSegmentSet::iterator 
MutableSegmentSet::get_intersecting_segments(MutableSegmentSet::iterator first, 
                                             MutableSegmentSet::iterator end)
{
    MutableSegmentSet::iterator last = first;
    ++last;
    while (last != end && last->slope() != first->slope() && 
           last->evaluate(m_scan_pos) == first->evaluate(m_scan_pos))
    {
        ++last;
    }
    return last;
}

void MutableSegmentSet::reorder()
{
    iterator first = this->begin();
    iterator last;
    iterator end = this->end();
    
    while (first != end)
    {
        last = get_intersecting_segments(first, end);
        if (std::distance(first, last) > 1)
        {
            this->reverse(first, last);
        }
        first = last;
    }
}

void MutableSegmentSet::reverse(iterator first, iterator last)
{
    MutableIter start(first);
    MutableIter finish(last);
    
    std::reverse(start, finish);
}

